Attribute VB_Name = "Enum_Callbacks"
Option Explicit

'==================================================================
'
' Window Enumeration Callback Module
' used by WindowEnums class
'
' 30 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


'------------------------------------------------------------------------
' Declarations

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (DestPtr As Any, SourcePtr As Any, ByVal NumOfBytes As Long)


'------------------------------------------------------------------------
' Get an object from a pointer

Private Function ObjectFromPtr(ByVal ObjectPtr As Long) As Object
  Dim Obj As Object
  Dim ObjPtr As Object
  
  On Error Resume Next
    Call CopyMemory(ObjPtr, ObjectPtr, 4) ' Turn the pointer into an ILLEGAL, UNCOUNTED interface (VB registers all object-var assignments)
    Set Obj = ObjPtr                      ' Assign to legal reference
    Call CopyMemory(ObjPtr, 0&, 4)        ' Destroy the illegal reference
    Set ObjectFromPtr = Obj
  On Error GoTo 0
End Function


'------------------------------------------------------------------------
' Callbacks that try to find and notify caller-objects about window found.

Public Function EnumWindows_CallBack(ByVal hWnd As Long, ByVal lParam As Long) As Long
  Dim ObjInst As WindowEnums
  Set ObjInst = ObjectFromPtr(lParam)
  If ObjInst Is Nothing Then
    Err.Raise 12345, "WindowEnum", "Got no object instance"
  Else
    EnumWindows_CallBack = ObjInst.RaiseEventGW(hWnd)
  End If
End Function

Public Function EnumChildWindows_CallBack(ByVal hWnd As Long, ByVal lParam As Long) As Long
  Dim ObjInst As WindowEnums
  Set ObjInst = ObjectFromPtr(lParam)
  If ObjInst Is Nothing Then
    Err.Raise 12345, "WindowEnum", "Got no object instance"
  Else
    EnumChildWindows_CallBack = ObjInst.RaiseEventGCW(hWnd)
  End If
End Function
